Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1090189 - Review Request: nodejs-lodash-cli - The Lo-Dash command-line interface
Summary: Review Request: nodejs-lodash-cli - The Lo-Dash command-line interface
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1090187 1090667
Blocks: nodejs-reviews 1090190
TreeView+ depends on / blocked
 
Reported: 2014-04-22 21:24 UTC by Tom Hughes
Modified: 2014-04-24 14:05 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-04-24 14:05:16 UTC
jamielinux: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Tom Hughes 2014-04-22 21:24:48 UTC
Spec URL: http://download.compton.nu/nodejs/nodejs-lodash-cli.spec
SRPM URL: http://download.compton.nu/nodejs/nodejs-lodash-cli-2.4.1-1.fc20.src.rpm
Fedora Account System Username: tomh

Description:
The Lo-Dash command-line interface for creating custom
builds & precompiling templates.

Comment 1 Jamie Nguyen 2014-04-23 18:31:14 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s) in
  its own file, then that file, containing the text of the license(s) for the
  package is included in %doc.
  Note: Cannot find license.jst in rpm(s)
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text

False positive.


nodejs-lodash-cli.noarch: E: script-without-shebang /usr/lib/node_modules/lodash-cli/lib/util.js
nodejs-lodash-cli.noarch: E: script-without-shebang /usr/lib/node_modules/lodash-cli/lib/minify.js

Remove executable bit from these.



[!]: %check is present and all tests pass.

Couldn't get the tests to work with either the bundled stuff in vendor, or by npm installed qunit and qunit-extras. I won't block on this.

However, I might have to block on this...


[!]: Package functions as described.

# mock -r fedora-rawhide-x86_64 --install ./nodejs-closure-compiler*.rpm
# mock -r fedora-rawhide-x86_64 --install ./nodejs-lodash-cli*.rpm
# mock -r fedora-rawhide-x86_64 --shell
# lodash backbone
Compressing lodash.custom.min using the Closure Compiler (simple)...

/usr/lib/node_modules/lodash-cli/lib/minify.js:396
      throw exception;
            ^
Error: Exception in thread "main" java.lang.NoClassDefFoundError: org/kohsuke/args4j/CmdLineException
	at java.lang.Class.getDeclaredMethods0(Native Method)
	at java.lang.Class.privateGetDeclaredMethods(Class.java:2688)
	at java.lang.Class.getMethod0(Class.java:2937)
	at java.lang.Class.getMethod(Class.java:1771)
	at sun.launcher.LauncherHelper.validateMainClass(LauncherHelper.java:544)
	at sun.launcher.LauncherHelper.checkAndLoadMain(LauncherHelper.java:526)
Caused by: java.lang.ClassNotFoundException: org.kohsuke.args4j.CmdLineException
	at java.net.URLClassLoader$1.run(URLClassLoader.java:372)
	at java.net.URLClassLoader$1.run(URLClassLoader.java:361)
	at java.security.AccessController.doPrivileged(Native Method)
	at java.net.URLClassLoader.findClass(URLClassLoader.java:360)
	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)
	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:308)
	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)
	... 6 more

    at ChildProcess.<anonymous> (/usr/lib/node_modules/closure-compiler/lib/index.js:64:15)
    at ChildProcess.EventEmitter.emit (events.js:98:17)
    at Process.ChildProcess._handle.onexit (child_process.js:797:12)


I'm not really sure what the root cause of this is. Seems it may be a bug in the closure-compiler package? Or perhaps the args4j package?


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: nodejs-lodash-cli-2.4.1-1.fc21.noarch.rpm
          nodejs-lodash-cli-2.4.1-1.fc21.src.rpm
nodejs-lodash-cli.noarch: W: spelling-error %description -l en_US precompiling -> recompiling, p recompiling, compiling
nodejs-lodash-cli.noarch: W: only-non-binary-in-usr-lib
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/glob /usr/lib/node_modules/glob
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/closure-compiler /usr/lib/node_modules/closure-compiler
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/uglify-js /usr/lib/node_modules/uglify-js@2
nodejs-lodash-cli.noarch: E: script-without-shebang /usr/lib/node_modules/lodash-cli/lib/util.js
nodejs-lodash-cli.noarch: E: script-without-shebang /usr/lib/node_modules/lodash-cli/lib/minify.js
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/lodash /usr/lib/node_modules/lodash
nodejs-lodash-cli.noarch: W: no-manual-page-for-binary lodash
nodejs-lodash-cli.src: W: spelling-error %description -l en_US precompiling -> recompiling, p recompiling, compiling
2 packages and 0 specfiles checked; 2 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-lodash-cli
nodejs-lodash-cli.noarch: W: spelling-error %description -l en_US precompiling -> recompiling, p recompiling, compiling
nodejs-lodash-cli.noarch: W: only-non-binary-in-usr-lib
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/glob /usr/lib/node_modules/glob
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/closure-compiler /usr/lib/node_modules/closure-compiler
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/uglify-js /usr/lib/node_modules/uglify-js@2
nodejs-lodash-cli.noarch: E: script-without-shebang /usr/lib/node_modules/lodash-cli/lib/util.js
nodejs-lodash-cli.noarch: E: script-without-shebang /usr/lib/node_modules/lodash-cli/lib/minify.js
nodejs-lodash-cli.noarch: W: dangling-symlink /usr/lib/node_modules/lodash-cli/node_modules/lodash /usr/lib/node_modules/lodash
nodejs-lodash-cli.noarch: W: no-manual-page-for-binary lodash
1 packages and 0 specfiles checked; 2 errors, 7 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-lodash-cli (rpmlib, GLIBC filtered):
    /usr/bin/env
    nodejs(engine)
    npm(closure-compiler)
    npm(glob)
    npm(lodash)
    npm(uglify-js)



Provides
--------
nodejs-lodash-cli:
    nodejs-lodash-cli
    npm(lodash-cli)



Source checksums
----------------
https://github.com/lodash/lodash-cli/archive/77c3c4f18a5d6e15c2a8aca7d7b51c0eab7f09ae/lodash-cli-77c3c4f18a5d6e15c2a8aca7d7b51c0eab7f09ae.tar.gz :
  CHECKSUM(SHA256) this package     : b4d52d7c68b148ac1f94c7be3e0dcca7157db96f44c3236b6417dd60d1747008
  CHECKSUM(SHA256) upstream package : b4d52d7c68b148ac1f94c7be3e0dcca7157db96f44c3236b6417dd60d1747008


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/bin/fedora-review -m fedora-rawhide-x86_64 -r -n nodejs-lodash-cli-2.4.1-1.fc20.src.rpm
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 2 Tom Hughes 2014-04-23 19:14:29 UTC
Yeah I haven't managed to get the tests to work yet - they just seem to spin doing something indeterminate.

Not sure why the other thing is failing - it was definitely working for me as part of the lodash-node build...

Comment 3 Jamie Nguyen 2014-04-23 19:56:48 UTC
Are you getting the same error? Or is it something on my system?

Comment 4 Tom Hughes 2014-04-23 21:55:23 UTC
Yes I can reproduce it - it seems to be a problem with the closure-compiler package in rawhide.

If I download the prebuilt compiler.jar for the same version from upstream and use that then in works - it's also nearly twice the size of the jar in the Fedora package.

Comment 5 Tom Hughes 2014-04-23 22:02:16 UTC
Opened BZ#1090667 against closure-compiler to try and get to the bottom of it.

Comment 6 Tom Hughes 2014-04-23 23:35:21 UTC
There's a new nodejs-closure-compiler at http://download.compton.nu/nodejs/nodejs-closure-compiler-0.2.6-2.fc20.src.rpm that patches the code to invoke the closure-compiler wrapper instead of linking in the jar.

With that package the "lodash backbone" command now works.

Comment 7 Tom Hughes 2014-04-24 06:03:52 UTC
With the closure compiler fix the tests also pass (using the vendored qunit) but they do take an hour to run on my machine!

Comment 8 Jamie Nguyen 2014-04-24 07:27:42 UTC
# lodash backbone
Compressing lodash.custom.min using the Closure Compiler (simple)...
Done. Size: 4734 bytes.
Compressing lodash.custom.min using the Closure Compiler (advanced)...
Done. Size: 4721 bytes.
Compressing lodash.custom.min using UglifyJS...
Done. Size: 4813 bytes.
Compressing lodash.custom.min using hybrid (simple)...
Done. Size: 4676 bytes.
Compressing lodash.custom.min using hybrid (advanced)...
Done. Size: 4706 bytes.

Package approved!

Comment 9 Tom Hughes 2014-04-24 07:31:59 UTC
New Package SCM Request
=======================
Package Name: nodejs-lodash-cli
Short Description: The Lo-Dash command-line interface
Owners: tomh jamielinux
Branches:
InitialCC:

Comment 10 Gwyn Ciesla 2014-04-24 12:57:10 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.